
/*jslint plusplus:false,white:false,undef: false, rhino: true, onevar: true, evil: true */
/*
Title: Upload de arquivo dbf

Envia para o servidor um arquivo local (dbf ou csv) e insere como uma camada no mapa.

Veja:

<i3GEO.arvoreDeTemas.dialogo.uploaddbf>

Arquivo: i3geo/ferramentas/uploaddbf/index.js.php

About: Licen&ccedil;a

i3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Minist&eacute;rio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@gmail.com

Este programa &eacute; software livre; voc&ecirc; pode redistribu&iacute;-lo
e/ou modific&aacute;-lo sob os termos da Licen&ccedil;a P&uacute;blica Geral
GNU conforme publicada pela Free Software Foundation;

Este programa &eacute; distribu&iacute;do na expectativa de que seja &uacute;til,
por&eacute;m, SEM NENHUMA GARANTIA; nem mesmo a garantia impl&iacute;cita
de COMERCIABILIDADE OU ADEQUA&Ccedil;&Atilde;O A UMA FINALIDADE ESPEC&Iacute;FICA.
Consulte a Licen&ccedil;a P&uacute;blica Geral do GNU para mais detalhes.
Voc&ecirc; deve ter recebido uma c&oacute;pia da Licen&ccedil;a P&uacute;blica Geral do
GNU junto com este programa; se n&atilde;o, escreva para a
Free Software Foundation, Inc., no endere&ccedil;o
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
*/
if(typeof(i3GEOF) === 'undefined'){
	var i3GEOF = {};
}
/*
Classe: i3GEOF.uploaddbf
*/
i3GEOF.uploaddbf = {
	/*
	Variavel: aguarde

	Estilo do objeto DOM com a imagem de aguarde existente no cabe&ccedil;alho da janela.
	*/
	aguarde: "",
	/*
		Para efeitos de compatibilidade antes da vers&atilde;o 4.7 que n&atilde;o tinha dicion&aacute;rio
	*/
	criaJanelaFlutuante: function(){
		i3GEOF.uploaddbf.iniciaDicionario();
	},
	/*
	Function: iniciaDicionario

	Carrega o dicion&aacute;rio e chama a fun&ccedil;&atilde;o que inicia a ferramenta

	O Javascript &eacute; carregado com o id i3GEOF.nomedaferramenta.dicionario_script
	*/
	iniciaDicionario: function(){
		if(typeof(i3GEOF.uploaddbf.dicionario) === 'undefined'){
			i3GEO.util.scriptTag(
				i3GEO.configura.locaplic+"/ferramentas/uploaddbf/dicionario.js",
				"i3GEOF.uploaddbf.iniciaJanelaFlutuante()",
				"i3GEOF.uploaddbf.dicionario_script"
			);
		}
		else{
			i3GEOF.uploaddbf.iniciaJanelaFlutuante();
		}
	},
	/*
	Function: inicia

	Inicia a ferramenta. &Eacute; chamado por criaJanelaFlutuante

	Parametro:

	iddiv {String} - id do div que receber&aacute; o conteudo HTML da ferramenta
	*/
	inicia: function(iddiv){
		try{
			$i(iddiv).innerHTML += i3GEOF.uploaddbf.html();
			new YAHOO.widget.Button(
				"i3GEOuploaddbfbotao1",
				{onclick:{fn: i3GEOF.uploaddbf.submete}}
			);
			i3GEO.util.radioEpsg(
				function(retorno)
				{$i("i3GEOuploaddbfListaepsg").innerHTML = retorno.dados;},
				"i3GEOuploaddbfListaepsg",
				"uploaddbf"
			);
		}
		catch(erro){i3GEO.janela.tempoMsg(erro);}
	},
	/*
	Function: html

	Gera o c&oacute;digo html para apresenta&ccedil;&atilde;o das op&ccedil;&otilde;es da ferramenta

	Retorno:

	String com o c&oacute;digo html
	*/
	html:function(){
		var ins = '<form id=i3GEOuploaddbff target="i3GEOuploaddbfiframe" action="'+i3GEO.configura.locaplic+'/ferramentas/uploaddbf/upload.php" method="post" ENCTYPE="multipart/form-data">' +
		'<p class="paragrafo" >'+$trad(1,i3GEOF.uploaddbf.dicionario)+': <br> '+
		'<select name="i3GEOuploaddbftipoarquivo"> '+
		'	<option value="dbf" select >dbf</option> '+
		'	<option value="csvpv" >csv ";"</option> '+
		'	<option value="csvv" >csv ","</option> '+
		'</select></p> '+

		'<p class="paragrafo" >'+$trad(2,i3GEOF.uploaddbf.dicionario)+': <br><input class=digitar type="text" size=32 name="i3GEOuploaddbfnomex" style="top:0px;left:0px"></p>' +
		'<p class="paragrafo" >'+$trad(3,i3GEOF.uploaddbf.dicionario)+': <br><input class=digitar type="text" size=32 name="i3GEOuploaddbfnomey" style="top:0px;left:0px"></p>' +

		'<p class="paragrafo" >'+$trad(4,i3GEOF.uploaddbf.dicionario)+': <br><input type="file" size=18 name="i3GEOuploaddbffile" style="top:0px;left:0px;cursor:pointer;"></p>' +
		'<p class=paragrafo >'+$trad(5,i3GEOF.uploaddbf.dicionario)+':</p>' +
		'<div id=i3GEOuploaddbfListaepsg width="98%" style="text-align:left;border:1px solid gray;left:0px;overflow:auto;height:60px"></div>' +
		'<br><p class="paragrafo" ><input id=i3GEOuploaddbfbotao1 type="button" value="'+$trad(6,i3GEOF.uploaddbf.dicionario)+'" size=12 name="submit">' +
		'<input type=hidden name=g_sid value="'+i3GEO.configura.sid+'" >' +
		'<input type="hidden" name="MAX_FILE_SIZE" value="100000">' +
		'</form>' +
		'<br><iframe name=i3GEOuploaddbfiframe style="text-align:left;border:1px solid gray;" width="98%" height="60px"></iframe>';
		return ins;
	},
	/*
	Function: iniciaJanelaFlutuante

	Cria a janela flutuante para controle da ferramenta.
	*/
	iniciaJanelaFlutuante: function(){
		var janela,divid,titulo,cabecalho,minimiza;
		cabecalho = function(){};
		minimiza = function(){
			i3GEO.janela.minimiza("i3GEOF.uploaddbf");
		};
		titulo = $trad("a2b")+" <a class=ajuda_usuario target=_blank href='" + i3GEO.configura.locaplic + "/ajuda_usuario.php?idcategoria=4&idajuda=26' >&nbsp;&nbsp;&nbsp;</a>";
		janela = i3GEO.janela.cria(
			"320px",
			"390px",
			"",
			"",
			"",
			titulo,
			"i3GEOF.uploaddbf",
			false,
			"hd",
			cabecalho,
			minimiza
		);
		divid = janela[2].id;
		$i("i3GEOF.uploaddbf_corpo").style.backgroundColor = "white";
		i3GEOF.uploaddbf.aguarde = $i("i3GEOF.uploaddbf_imagemCabecalho").style;
		i3GEOF.uploaddbf.inicia(divid);
	},
	/*
	Function: submete

	Envia o arquivo ao servidor
	*/
	submete: function(){
		if(i3GEOF.uploaddbf.aguarde.visibility==="visible")
		{return;}
		i3GEOF.uploaddbf.aguarde.visibility="visible";
		$i("i3GEOuploaddbff").submit();
	}
};